#include	<gl/glut.h>
#include	<stdio.h>
#include	<math.h>

float	angle  = 0.0f;
float	angle2 = 0.0f;
float	d      = 3.0f / (float)sqrt ( 3 );

void    drawBox ( GLfloat x1, GLfloat x2, GLfloat y1, GLfloat y2, GLfloat z1, GLfloat z2 )
{
        glBegin ( GL_POLYGON );         // front face
		  glColor3f  ( 0, 0, 1 );		// blue
          glNormal3f ( 0, 0, 1 );
          glVertex3f ( x1, y1, z2 );
          glVertex3f ( x2, y1, z2 );
          glVertex3f ( x2, y2, z2 );
          glVertex3f ( x1, y2, z2 );
        glEnd ();

        glBegin ( GL_POLYGON );         // back face
		  glColor3f  ( 1, 1, 0 );		//
          glNormal3f ( 0.0, 0.0, -1.0 );
          glVertex3f ( x2, y1, z1 );
          glVertex3f ( x1, y1, z1 );
          glVertex3f ( x1, y2, z1 );
          glVertex3f ( x2, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // left face
		  glColor3f  ( 0, 1, 0 );		// green
          glNormal3f ( -1.0, 0.0, 0.0 );
          glVertex3f ( x1, y1, z1 );
          glVertex3f ( x1, y1, z2 );
          glVertex3f ( x1, y2, z2 );
          glVertex3f ( x1, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // right face
	      glColor3f  ( 1, 0, 1 );
          glNormal3f ( 1.0, 0.0, 0.0 );
          glVertex3f ( x2, y1, z2 );
          glVertex3f ( x2, y1, z1 );
          glVertex3f ( x2, y2, z1 );
          glVertex3f ( x2, y2, z2 );
        glEnd ();

        glBegin ( GL_POLYGON );         // top face
		  glColor3f  ( 1, 0, 0 );		// red
          glNormal3f ( 0.0, 1.0, 0.0 );
          glVertex3f ( x1, y2, z2 );
          glVertex3f ( x2, y2, z2 );
          glVertex3f ( x2, y2, z1 );
          glVertex3f ( x1, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // bottom face
		  glColor3f  ( 0, 1, 1 );
          glNormal3f ( 0.0, -1.0, 0.0 );
          glVertex3f ( x2, y1, z2 );
          glVertex3f ( x1, y1, z2 );
          glVertex3f ( x1, y1, z1 );
          glVertex3f ( x2, y1, z1 );
        glEnd ();
}

void init ()
{
	glClearColor ( 0.0, 0.0, 0.0, 1.0 );
	glEnable     ( GL_DEPTH_TEST );
}

void	animate ()
{
	angle  += 0.75f;	// * glutGet ( GLUT_ELAPSED_TIME );
	angle2 += 0.1f;

	glutPostRedisplay ();
}

void display ()
{
	glClear ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    glMatrixMode   ( GL_MODELVIEW );
    glLoadIdentity ();
    gluLookAt      ( 0, 0, 0,		// eye
	 				 1, 1, 1,		// center
					 0, 1, 0 );		// up


	glTranslatef ( 4, 4, 4 );
	glRotatef    ( angle2, 1, -1, 0 );
	glTranslatef ( d - 1.5f, d - 1.5f, d - 1.5f );

	glTranslatef ( 1.5f, 1.5f, 1.5f );			// move cube from the center
	glRotatef    ( angle, 1.0f, 1.0f, 0.0f );
	glTranslatef ( -1.5f, -1.5f, -1.5f );		// move cube into the center

	drawBox ( 1, 2, 1, 2, 1, 2 );
	
	glutSwapBuffers ();
}

void reshape ( int w, int h ) 
{
   glViewport     ( 0, 0, (GLsizei)w, (GLsizei)h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   gluPerspective ( 60.0, (GLfloat)w/(GLfloat)h, 1.0, 60.0 );
/*
   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
   gluLookAt      ( 0.0, 0.0, 0.0,		// eye
					1.0, 1.0, 1.0,		// center
					0.0, 1.0, 0.0 );
*/
}

void key ( unsigned char key, int x, int y )
{
  if ( key == 27 || key == 'q' || key == 'Q' )		//quit requested
    exit ( 0 );
}


int main ( int argc, char ** argv )
{
								//initialise glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );   
	glutInitWindowSize  ( 400, 400 );

								// create window
	int	glWin = glutCreateWindow ( "OpenGL example 4" );

	init();
								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
    glutKeyboardFunc ( key );
	glutIdleFunc     ( animate );

	glutMainLoop ();

	return 0;
}
